Interconnecting Limited Domains Based on Declared Communication Requirements
Internet-Draft draft-bormann-t2trg-interconnect-declared-02
Carsten Bormann
Universität Bremen TZI
Postfach 330440
Bremen
D-28359
Germany
+49-421-218-63921
cabo@tzi.org
11 July 2022
Internet-Draft
"Limited Domains" are parts of an internet that may have notable differences or are just convenient to separate from the general Internet and can be delimited from that and from other Limited Domains by a defined boundary (the "border").
This memo focuses on the case where the nodes inside the Limited Domain want to interact with nodes on (or reachable via) the general Internet, but need some assistance at the border that is cognizant about the specific properties of the nodes in the Limited Domain.
Self-Descriptions can provide the information needed for this assistance.
About This Document
Status information for this document may be found at https://datatracker.ietf.org/doc/draft-bormann-t2trg-interconnect-declared/.
Discussion of this document takes place on the Thing-to-Thing Research Group mailing list (mailto:t2trg@irtf.org), which is archived at https://mailarchive.ietf.org/arch/browse/t2trg/.
Introduction
[RFC8799] introduces the concept of "Limited Domains", i.e., parts of an internet that may have notable differences or are just convenient to separate from the general Internet and can be delimited from that and from other Limited Domains by a defined boundary (the "border").
Limited Domains are not a new concept, but they recently have gained significant attention as a way to accelerate innovation without always having to wait for the whole Internet to accept a new feature [USEFUL].
Some Limited Domains can be directly connected to or interconnected via the Internet -- rules they use internally simply lose their force outside the Limited Domain. Some require stripping off some structures or translating some fields on the border to the Internet. Some can only be interconnected by running tunnels on top of the Internet.
This memo focuses on the case where the nodes inside the Limited Domain want to interact with nodes on (or reachable via) the general Internet, but need some assistance at the border that is cognizant about the specific properties of the nodes in the Limited Domain.
6LoWPAN header compression [RFC6282] actually is such an example, which can be considered a very small Limited Domain -- initially just the link and adaptation layer between two LoWPAN nodes, which themselves otherwise feel like standard Internet nodes. (6LoWPAN neighbor discovery [RFC6775] already extends the Limited Domain out to the border router (6LBR), but let's focus on header compression itself for now.) Extending the Limited Domain to more than two nodes may allow the nodes inside the Limited Domain to make use of the knowledge that all of them share some common procedures, such as using the [RFC8138] routing header (6LoRH); it is then the job of the border router (6LBR) to decapsulate this form into packets that can be used in the global Internet and to appropriately encapsulate global Internet packets on the way in. (Virtual Reassembly Buffers (VRBs, [RFC8930]) simulate a subnet-size Limited Domain based on [RFC6282]'s hop-by-hop ones.)
This memo uses examples from the area of the Internet of Things (IoT), both because the author is most familiar with it and because a concept of self-descriptions has already been developed for this area, which provide new opportunities for organizing Limited Domains (Section 3). (To do: add more examples from outside the IoT core.)
Terminology
Limited Domain:
An area in a network that is separate from others by notable internal differences and/or by a strong administrative demarcation. Examples are found in Section 4 of [RFC8799], however this document is not limiting itself to those or to the definition in [RFC8799]. In contrast to some other usage, the nodes in a Limited Domain are expected to normally form a connected graph, possibly by employing tunnels between them. However, not all nodes in a Limited Domain always need to be aware of their situation or implement all the internal differences.
Illustration for terms

a

i

L

B

i

n

n

t

D

e

t

t

L

d

o

D

m

m

m

Y

d

i

i

D

X

e

B

r

L

t

i

i

1

m

D

L

a

o

Z

L

n

2

i

D

D

n

3

B

i

o

m

I

e

n

a

i

e

m

t

B

d

e

L

.---------------------. .------------.
|                     | |            |
|                   .-+-+-.  Limited |
|                   |  B  |  Domain  |
|                   '-+-+-'    LD2   |
|                     | |            |
|                     | '------------'
|   Limited Domain    |
|       LD1           |     .---------.     .------------.
|                     |    /           \    |            |
|                   .-+--./             \.--+-.  Limited |
|      .---.        |  B +   Internet    + B  |  Domain  |
|      | Z |        '-+--'\             /'--+-'    LD3   |
|      '---'          |    \           /    |            |
|                     |     '-+-----+-'     '------------'
'---------------------'       |     |
                            .-+-.  .+-..---.
                            | X | | B ++ Y |
                            '---'  '--''---'

Figure 1 illustrates the following additional terms:
Border:
qualifier for network elements (B) (as in "border router" etc.) that are situated on the boundary between a Limited Domain and a different one and/or the general Internet.
Internally interoperable Limited Domains:
Limited Domains that can accommodate nodes that can operate as if they were in the Internet (Z).
Globally interoperable Limited Domains:
Limited Domains that can interoperate with nodes in the global Internet (X).
Externally interoperable Limited Domains:
Limited Domains that can interoperate via the Internet (LD1), but possibly limited to interoperation with other Limited Domains (LD3) or with specially equipped Internet nodes (Limited Domains of size 1, Y logically containing a B).
Internet, Global Internet, General Internet:
(TBD, clarify usage here)
Desirable Communication
All the examples so far presume an environment where it is desirable that any node can communicate with any other node. This has certainly served well as a guiding principle for quickly improving the value of a network: Leaving open the potential to communicate maximizes the potential network effect [METCALFE]. However, firewalls are then widely used to suppress some of these potential communication paths [FIREWALL]. MUD [RFC8520] was designed to aid routers and switches in setting up limited connectivity to this end.
In the MUD architecture, we first build a system that fundamentally supports unlimited connectivity from everyone to everyone and then restrict it based on self-descriptions of the nodes. An alternative approach would be an architecture that does not provide any connectivity unless and until that is authorized by declared communication requirements that have in turn been authorized by some management entity.
Example: Addressing Desirable Peers Only
There may be other reasons for pursuing an architecture that limits itself to desirable communication only. A trivial, but maybe not overly useful example would be to number all the addresses of correspondent hosts allowed by the self-descriptions and replace the IP addresses in the packets by these numbers.
If this limitation becomes part of the architecture, protocols used inside the Limited Domains could completely get rid of IP addresses and use just the correspondent numbers (possibly packaged in something that looks like an IP address, but is limited in its variability to just encapsulating that number).
The border router would become a NAT, but one that is acting based on extensive, precomputable information about the communication requirements inside the Limited Domain, instead of learning and potentially losing dynamic state that becomes a single point of failure.
Again, this is a trivial example, but it should be sufficient as a motivation for having a look at employing knowledge about the nodes and their communication requirements in a Limited Domain for interconnecting this with the Internet (and thus possibly to like-minded (Limited Domains on the other side of an Internet path).
Self-Descriptions
Note that not all of the information that may be needed as a description of Limited Domain nodes can come from MUD-like class definitions. Limited Domain nodes are instantiations of these classes, where the instantiations will differ between each other in details. Different Limited Domain nodes may also be assigned a different purpose in life, causing a need to further parameterize the self-description.
Alongside a discussion of an interconnection architecture that can make use of self-descriptions would therefore need to be a discussion on how to structure self-description classes with this purpose in mind and how to parameterize these and derive description instances.
For the Internet of Things (IoT), additional self-description techniques have been defined that can provide information for Limited Domain network elements. A fully instance-oriented description of an IoT device is provided by a W3C WoT (Web of Things) Thing Description [TD]. W3C WoT is presently in the process of adding a class-based description technique to TDs, the Thing Model (previously called Thing Description Template, TDT) [TD-WD]. The communication patterns offered by the device are detailed in Protocol Bindings, which can contain URIs combined with protocol-specific vocabulary ([TD-PB], currently defined for HTTP, CoAP, MQTT). An experimental extension to TDs that enables deriving the configuration of Time-Sensitive Networking (TSN) networks from the self-description is described in [TD-OPC-UA].
An IoT-oriented description technique that, unlike TD, is class-based from the outset is the Semantic Definition Format (SDF) for Data and Interactions of Things [I-D.ietf-asdf-sdf]. A concept similar to WoT Protocol Bindings is not defined yet, but a combination of MUD and SDF descriptions could provide a basic description of a device situated in a Limited Domain.
The Constrained RESTful Environments (CoRE) architecture also provides instance-oriented self-descriptions in the form of the CoRE Link Format [RFC6690], an instance of which is provided by each CoAP server under /.well-known/core. Link-format information, as well as self-describing information in the newer CoRAL format [I-D.ietf-core-coral], can be stored in the CoRE Resource Directory [RFC9176].
All these potential sources of (self-)description only provide meager information about purpose-in-life, i.e., beyond the intrinsic properties of the device. Obtaining a full description of the communication requirements of a node (including its desirable correspondence nodes) will therefore require additional input, beyond the class-based self-descriptions of the devices.
Directions of Work
The above discussion leads us to the following interrelated areas for further exploration:
1. Extending the self-description mechanisms to provide more information that may be useful in a Limited Domain.
2. Merging the self-description information with other configuration/management information (such as purpose-in-life) that may be available for the Limited Domain.
3. Defining Limited Domain architectures that can benefit from information made available by (1) and (2), including defining the operation of network elements and nodes inside the Limited Domain.
4. Defining border network element functionality that makes such a Limited Domain a Globally Interoperable Limited Domain.
5. Defining border network element functionality that makes such a Limited Domain an Externally Interoperable Limited Domain.
6. Discovery between Limited Domains, between Limited Domain nodes (Rendezvous problem); establishment of communications (cf. [RFC8445]).
7. Defining appropriate security workflows and the supporting security mechanisms for items 4 to 4.
8. Addressing operational considerations for items 4 to 4.
9. Addressing privacy considerations for items 4 to 4.
IANA Considerations
This document contains no requests to IANA.
Security Considerations
The security considerations of [RFC8799] apply.
Item 4 of Section 4 raises the need for security work, one example of which might be:
Self-descriptions of nodes in many cases need to undergo an authorization process before they can be used as the basis of network configuration. The authorization process sketched by [RFC8520] may be too simplistic, in particular the simplified number of stakeholders assumed. The present document is not providing answers in this space, but needs to raise the issue.
Informative References
[RFC8520]

Manufacturer Usage Description Specification
E. Lear
R. Droms
D. Romascanu
March 2019
RFC 8520
DOI 10.17487/RFC8520
[RFC8799]

Limited Domains and Internet Protocols
B. Carpenter
B. Liu
July 2020
RFC 8799
DOI 10.17487/RFC8799
[RFC6282]

Compression Format for IPv6 Datagrams over IEEE 802.15.4-Based Networks
J. Hui, Ed.
P. Thubert
September 2011
RFC 6282
DOI 10.17487/RFC6282
[RFC6775]

Neighbor Discovery Optimization for IPv6 over Low-Power Wireless Personal Area Networks (6LoWPANs)
Z. Shelby, Ed.
S. Chakrabarti
E. Nordmark
C. Bormann
November 2012
RFC 6775
DOI 10.17487/RFC6775
[RFC8138]

IPv6 over Low-Power Wireless Personal Area Network (6LoWPAN) Routing Header
P. Thubert, Ed.
C. Bormann
L. Toutain
R. Cragie
April 2017
RFC 8138
DOI 10.17487/RFC8138
[RFC8930]

On Forwarding 6LoWPAN Fragments over a Multi-Hop IPv6 Network
T. Watteyne, Ed.
P. Thubert, Ed.
C. Bormann
November 2020
RFC 8930
DOI 10.17487/RFC8930
[RFC8445]

Interactive Connectivity Establishment (ICE): A Protocol for Network Address Translator (NAT) Traversal
A. Keranen
C. Holmberg
J. Rosenberg
July 2018
RFC 8445
DOI 10.17487/RFC8445
[RFC6690]

Constrained RESTful Environments (CoRE) Link Format
Z. Shelby
August 2012
RFC 6690
DOI 10.17487/RFC6690
[RFC9176]

Constrained RESTful Environments (CoRE) Resource Directory
C. Amsüss, Ed.
Z. Shelby
M. Koster
C. Bormann
P. van der Stok
April 2022
RFC 9176
DOI 10.17487/RFC9176
[I-D.ietf-core-coral]

The Constrained RESTful Application Language (CoRAL)
Christian Amsüss
Thomas Fossati
ARM
7 March 2022
Internet-Draft draft-ietf-core-coral-05
[I-D.ietf-asdf-sdf]

Semantic Definition Format (SDF) for Data and Interactions of Things
Michael Koster
PassiveLogic
Carsten Bormann
Universität Bremen TZI
30 June 2022
Internet-Draft draft-ietf-asdf-sdf-12
[METCALFE]

Metcalfe's Law after 40 Years of Ethernet
Bob Metcalfe
December 2013
Computer vol. 46, no. 12, pp. 26-31
DOI 10.1109/mc.2013.374
[FIREWALL]

Network firewalls
S.M. Bellovin
W.R. Cheswick
September 1994
IEEE Communications Magazine vol. 32, no. 9, pp. 50-57
DOI 10.1109/35.312843
[TD]

Web of Things (WoT) Thing Description
April 2020
W3C Recommendation
(Link errors corrected 23 June 2020)
[TD-WD]

Web of Things (WoT) Thing Description 1.1
May 2021
W3C Editor's Draft
[TD-PB]

Web of Things (WoT) Binding Templates
January 2020
W3C Working Group Note
[TD-OPC-UA]

Bringing deterministic industrial networking to the W3C web of things with TSN and OPC UA
Luca Sciullo
University of Bologna, Bologna, Italy
Sushmit Bhattacharjee
Huawei Technologies, Munich, Germany
Matthias Kovatsch
Huawei Technologies, Munich, Germany
October 2020
Proceedings of the 10th International Conference on the Internet of Things
DOI 10.1145/3410992.3410997
[USEFUL]

Limited domains considered useful
Brian Carpenter
The University of Auckland
Jon Crowcroft
University of Cambridge
Dirk Trossen
Huawei
July 2021
ACM SIGCOMM Computer Communication Review vol. 51, no. 3, pp. 22-28
DOI 10.1145/3477482.3477487
Acknowledgments
Adrian Farrel provided substantive comments as well as the basis for Figure 1.